using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Oqtane.Databases.Interfaces;
using Oqtane.Migrations;
using System;
using SZUAbsolventenverein.Module.EventRegistration.Migrations.EntityBuilders;
using SZUAbsolventenverein.Module.EventRegistration.Repository;

namespace SZUAbsolventenverein.Module.EventRegistration.Migrations
{
    [DbContext(typeof(EventRegistrationContext))]
    [Migration("SZUAbsolventenverein.Module.EventRegistration.01.00.00.05")]
    public class AddDescriptionDateTimeLocation : MultiDatabaseMigration
    {
        public AddDescriptionDateTimeLocation(IDatabase database) : base(database)
        {
        }

        protected override void Up(MigrationBuilder migrationBuilder)
        {
            var entityBuilder = new EventEntityBuilder(migrationBuilder, ActiveDatabase);
            entityBuilder.AddMaxStringColumn("Description", false, true, ""); // Contents for RichTextEditor
            entityBuilder.AddDateTimeColumn("EventDate", false, new DateTime()); // DateTime for the event
            entityBuilder.AddStringColumn("Location", 100, false, true, ""); // Location of the event
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            var entityBuilder = new EventEntityBuilder(migrationBuilder, ActiveDatabase);
            entityBuilder.DropColumn("Description"); // RichTextEditor
            entityBuilder.DropColumn("EventDate"); // DateTime
            entityBuilder.DropColumn("Location"); // Location 0
        }
    }
}
